// SplitterWindowControlCtl.cpp : Implementation of the CSplitterWindowControlCtrl ActiveX Control class.

#include "stdafx.h"
#include "SplitterWindowControl.h"
#include "SplitterWindowControlCtl.h"
#include "SplitterWindowControlPpg.h"
#include "SplitterControlView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



IMPLEMENT_DYNCREATE(CSplitterWindowControlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CSplitterWindowControlCtrl, COleControl)
	//{{AFX_MSG_MAP(CSplitterWindowControlCtrl)
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CSplitterWindowControlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CSplitterWindowControlCtrl)
	DISP_PROPERTY_NOTIFY(CSplitterWindowControlCtrl, "strFirstControlName", m_strFirstControlName, OnStrFirstControlNameChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CSplitterWindowControlCtrl, "strSecondControlName", m_strSecondControlName, OnStrSecondControlNameChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CSplitterWindowControlCtrl, "bVertical", m_bVertical, OnBVerticalChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CSplitterWindowControlCtrl, "intFirstPaneSize", m_intFirstPaneSize, OnIntFirstPaneSizeChanged, VT_I2)
	DISP_PROPERTY_EX(CSplitterWindowControlCtrl, "_pointer", GetPointer, SetPointer, VT_I4)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CSplitterWindowControlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CSplitterWindowControlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CSplitterWindowControlCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CSplitterWindowControlCtrl, 1)
	PROPPAGEID(CSplitterWindowControlPropPage::guid)
END_PROPPAGEIDS(CSplitterWindowControlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CSplitterWindowControlCtrl, "SPLITTER.SplitterCtrl.1",
	0xef42cc66, 0x68b4, 0x11d2, 0xb8, 0x17, 0xdd, 0xf1, 0x21, 0x7c, 0x87, 0x2f)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CSplitterWindowControlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DSplitterWindowControl =
		{ 0xef42cc64, 0x68b4, 0x11d2, { 0xb8, 0x17, 0xdd, 0xf1, 0x21, 0x7c, 0x87, 0x2f } };
const IID BASED_CODE IID_DSplitterWindowControlEvents =
		{ 0xef42cc65, 0x68b4, 0x11d2, { 0xb8, 0x17, 0xdd, 0xf1, 0x21, 0x7c, 0x87, 0x2f } };



/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwSplitterWindowControlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CSplitterWindowControlCtrl, IDS_SPLITTERWINDOWCONTROL, _dwSplitterWindowControlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl::CSplitterWindowControlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CSplitterWindowControlCtrl

BOOL CSplitterWindowControlCtrl::CSplitterWindowControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SPLITTERWINDOWCONTROL,
			IDB_SPLITTERWINDOWCONTROL,
			afxRegApartmentThreading,
			_dwSplitterWindowControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl::CSplitterWindowControlCtrl - Constructor

CSplitterWindowControlCtrl::CSplitterWindowControlCtrl()
{
	InitializeIIDs(&IID_DSplitterWindowControl, &IID_DSplitterWindowControlEvents);

	// TODO: Initialize your control's instance data here.
	m_bVertical=TRUE;
	m_pSplitter=NULL;
	m_intFirstPaneSize=50;

}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl::~CSplitterWindowControlCtrl - Destructor

CSplitterWindowControlCtrl::~CSplitterWindowControlCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl::OnDraw - Drawing function

void CSplitterWindowControlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl::DoPropExchange - Persistence support

void CSplitterWindowControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
	PX_String(pPX,_T("strFirstControlName"),m_strFirstControlName);
	PX_String(pPX,_T("strSecondControlName"),m_strSecondControlName);
	PX_Bool(pPX,_T("bVertical"),m_bVertical);
	PX_Short(pPX,_T("intFirstPaneSize"),m_intFirstPaneSize);
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl::OnResetState - Reset control to default state

void CSplitterWindowControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl::AboutBox - Display an "About" box to the user

void CSplitterWindowControlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_SPLITTERWINDOWCONTROL);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl message handlers
void CSplitterWindowControlCtrl::RecreateSplitterWindow()
{
	if(m_wndFrame.m_hWnd)
		m_wndFrame.DestroyWindow();

	CRect rectClient;
	GetClientRect(rectClient);

	m_wndFrame.Create(NULL, NULL, WS_CHILD|WS_VISIBLE, rectClient, this);

	int		nRows,nColumns;
	CPoint	ptPanes[2];
	CSize	sizePanes[2];
	if(m_bVertical)
	{
		nRows=1;
		nColumns=2;
		ptPanes[0]=CPoint(0,0);
		sizePanes[0]=CSize(m_intFirstPaneSize,rectClient.Height());
		ptPanes[1]=CPoint(0,1);
		sizePanes[1]=sizePanes[0];
	}
	else
	{
		nRows=2;
		nColumns=1;
		ptPanes[0]=CPoint(0,0);
		sizePanes[0]=CSize(rectClient.Width(),m_intFirstPaneSize);
		ptPanes[1]=CPoint(1,0);
		sizePanes[1]=sizePanes[0];
	}
	
	m_pSplitter=new CControlsSplitterWnd;
	m_pSplitter->CreateStatic(&m_wndFrame,nRows,nColumns);
			
	CCreateContext context;
	context.m_pCurrentDoc = NULL;
	context.m_pCurrentFrame=&m_wndFrame;

	m_pSplitter->CreateView(ptPanes[0].x, ptPanes[0].y, RUNTIME_CLASS(CSplitterControlView),sizePanes[0],&context);
	m_pSplitter->CreateView(ptPanes[1].x, ptPanes[1].y, RUNTIME_CLASS(CSplitterControlView),sizePanes[1],&context);

	RepositionSplitter();
}

short CSplitterWindowControlCtrl::GetFirstPaneSize() const
{
	int size;
	if(m_bVertical)
	{
		int cxMin;
		m_pSplitter->GetColumnInfo(0, size, cxMin);
	}
	else
	{
		int cyMin;
		m_pSplitter->GetRowInfo(0, size, cyMin);
	}

	return size;
}

void CSplitterWindowControlCtrl::SetFirstPaneSize(short size)
{
	if(m_bVertical)
		m_pSplitter->SetFirstColumnSize(size);
	else
		m_pSplitter->SetFirstRowSize(size);
}


void CSplitterWindowControlCtrl::RepositionSplitter()
{
	CRect rectClient;
	GetClientRect(rectClient);

	if(m_wndFrame.GetSafeHwnd())
	{
		m_wndFrame.MoveWindow(rectClient);
		if(m_pSplitter->GetSafeHwnd())
		{
			m_pSplitter->MoveWindow(rectClient);
			m_pSplitter->RecalcLayout();
		}
	}
}



BOOL CSplitterWindowControlCtrl::CreateControlWindow(HWND hWndParent, const CRect& rcPos,LPCRECT prcClipped)
{
	if(COleControl::CreateControlWindow(hWndParent,rcPos,prcClipped))
	{
		if(!m_wndFrame.m_hWnd)
			RecreateSplitterWindow();
		return TRUE;
	}

	return FALSE;
}





CString CSplitterWindowControlCtrl::GetExtendedName(IDispatchPtr pDispatch)
{
	COleVariant var;
	DISPPARAMS dispparamsNoArgs = {NULL, NULL, 0, 0};
	
	HRESULT hr = E_FAIL; 

	hr=pDispatch->Invoke(DISPID_AMBIENT_DISPLAYNAME,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_PROPERTYGET |	DISPATCH_METHOD,&dispparamsNoArgs,&var, NULL, NULL);

	if(FAILED(hr))
	{
		DISPID dispID=0;
		LPWSTR lpName[1] = { (WCHAR *)L"Name" };
        hr = pDispatch->GetIDsOfNames(IID_NULL, lpName, 1,LOCALE_SYSTEM_DEFAULT, &dispID);

		if(SUCCEEDED(hr))
			hr=pDispatch->Invoke(dispID,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_PROPERTYGET |	DISPATCH_METHOD,&dispparamsNoArgs,&var, NULL, NULL);
			
	}

	if(FAILED(hr))
		return _T("");

	return CString(var.bstrVal);
}



void CSplitterWindowControlCtrl::GetOtherControlsOnTheContainer(CControlInfoArray& arrayControls)
{
	if(!m_pClientSite)
		return;

	IOleContainerPtr	pOleContainer;
	IEnumUnknownPtr		pEnumUnk;
		
	if(FAILED(m_pClientSite->GetContainer(&pOleContainer))) 
		 return;

	if(FAILED(pOleContainer->EnumObjects(OLECONTF_EMBEDDINGS |OLECONTF_OTHERS,&pEnumUnk))) 
		return;

	IUnknownPtr					pUnk;
	HRESULT						hr = E_FAIL;
	
	while(pEnumUnk->Next(1,&pUnk,NULL) == S_OK) 
	{
		IOleObjectPtr pOleObject;
		hr = pUnk->QueryInterface(IID_IOleObject,(void**)&pOleObject);

		if(SUCCEEDED(hr)) 
		{
			//ActiveX control
			IOleClientSitePtr pClientSite;
			pOleObject->GetClientSite(&pClientSite);
		
			IDispatchPtr pAmbientDispatch;	
			pClientSite->QueryInterface(IID_IDispatch,(void**)&pAmbientDispatch);

			if(pAmbientDispatch)
			{
				CControlInfo info;
				info.m_strName=GetExtendedName(pAmbientDispatch);
				if(!info.m_strName.IsEmpty())
				{
					info.m_pOleObject=pOleObject;
					arrayControls.Add(info);
				}
			}
		}

		pUnk=NULL;
	}
}





void CSplitterWindowControlCtrl::OnStrFirstControlNameChanged() 
{
	// TODO: Add notification handler code
	SetModifiedFlag();
}

void CSplitterWindowControlCtrl::OnStrSecondControlNameChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CSplitterWindowControlCtrl::OnBVerticalChanged() 
{
	// TODO: Add notification handler code
	if(!AmbientUserMode())
		RecreateSplitterWindow();
	SetModifiedFlag();
}

void CSplitterWindowControlCtrl::OnIntFirstPaneSizeChanged() 
{
	// TODO: Add notification handler code
	SetFirstPaneSize(m_intFirstPaneSize);
	SetModifiedFlag();
}

long CSplitterWindowControlCtrl::GetPointer() 
{
	// TODO: Add your property handler here
	return long(this);
}

void CSplitterWindowControlCtrl::SetPointer(long nNewValue) 
{
	// TODO: Add your property handler here
	SetNotSupported();
}

void CSplitterWindowControlCtrl::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==777)
	{
		KillTimer(777);
		m_pSplitter->AdjustControlsToPanes();
	}

	COleControl::OnTimer(nIDEvent);
}


void CSplitterWindowControlCtrl::OnAmbientPropertyChange(DISPID dispid) 
{
	// TODO: Add your specialized code here and/or call the base class
	COleControl::OnAmbientPropertyChange(dispid);
	if(dispid==DISPID_AMBIENT_USERMODE && GetSafeHwnd())
		SetTimer(777,1,NULL);
}

void CSplitterWindowControlCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	RepositionSplitter();
}

void CSplitterWindowControlCtrl::OnMove(int x, int y) 
{
	COleControl::OnMove(x, y);
	
	// TODO: Add your message handler code here
	RepositionSplitter();
}

void CSplitterWindowControlCtrl::DelayControlsReposition()
{
	SetTimer(777,1,NULL);
}

//////////////////////////////////////////////////////////////////////////
int CControlInfoArray::IndexOf(LPCTSTR lpstrName)
{
	for(int i=0; i<GetSize(); i++)
	{
		if(GetAt(i).m_strName==lpstrName)
			return i;
	}

	return -1;
}

/////////////////////////////////////////////////////////////////////////
CSplitterWindowControlCtrl* CControlsSplitterWnd::GetParentActiveXControl()
{
	return (CSplitterWindowControlCtrl*)GetParent()->GetParent();
}

HWND GetContainerWindow(IOleClientSitePtr pClientSite)
{
	IOleWindowPtr pWindow;
	if(SUCCEEDED(pClientSite->QueryInterface(IID_IOleWindow,(void**)&pWindow)))
	{
		HWND wnd=NULL;
		pWindow->GetWindow(&wnd);
		return wnd;
	}

	IOleInPlaceSitePtr pIPSite=pClientSite;

	IOleInPlaceFramePtr pFrame;
	IOleInPlaceUIWindowPtr pDoc;
	RECT rcPosRect,rcClipRect;
	OLEINPLACEFRAMEINFO FrameInfo;
	FrameInfo.cb=sizeof(OLEINPLACEFRAMEINFO);

	if(SUCCEEDED(pIPSite->GetWindowContext(&pFrame,&pDoc,&rcPosRect,&rcClipRect,&FrameInfo)))
	{
		HWND hwnd=NULL;
		if(pDoc)
			pDoc->GetWindow(&hwnd);

		if(!hwnd)
		{
			if(pFrame)
				pFrame->GetWindow(&hwnd);
		}

		return hwnd;
	}

	return NULL;
}


void CControlsSplitterWnd::PlaceControlOnPane(LPCTSTR lpstrControlName,CWnd* pWndPane,CControlInfoArray& arrayControls)
{
	int nPos=arrayControls.IndexOf(lpstrControlName);
	if(nPos!=-1)
	{
		IOleInPlaceObjectPtr pOleInPlaceObject;
		IOleObjectPtr pOleObject=arrayControls[nPos].m_pOleObject;
		pOleObject->QueryInterface(IID_IOleInPlaceObject,(void**)&pOleInPlaceObject);
		if(pOleInPlaceObject)
		{
			HWND hwndControl=NULL;
			pOleInPlaceObject->GetWindow(&hwndControl);

			if(::IsWindow(hwndControl))
			{
				CRect rectClient;
				pWndPane->GetClientRect(rectClient);
				
				//Convert coordinates to the container's ones
				CRect rectObject(rectClient);
				pWndPane->ClientToScreen(rectObject);

				IOleClientSitePtr pClientSite;
				pOleObject->GetClientSite(&pClientSite);

				
				CWnd wndContainer;
				wndContainer.m_hWnd=GetContainerWindow(pClientSite);
				
				wndContainer.ScreenToClient(rectObject);
				wndContainer.m_hWnd=NULL;
				
				CSize size;
				pOleObject->SetExtent(DVASPECT_CONTENT,&size);
				pOleInPlaceObject->SetObjectRects(rectObject,rectObject);

				size=rectObject.Size();
				CClientDC dc(this);
				dc.DPtoHIMETRIC(&size);
				pOleObject->SetExtent(DVASPECT_CONTENT,&size);

			}
			else
				GetParentActiveXControl()->DelayControlsReposition();
		}
	}
}


void CControlsSplitterWnd::AdjustControlsToPanes()
{
	CSplitterWindowControlCtrl* pControl=GetParentActiveXControl();
	pControl->m_intFirstPaneSize=pControl->GetFirstPaneSize();

	if(!pControl->AmbientUserMode())
		return;

	CControlInfoArray arrayControls;
	pControl->GetOtherControlsOnTheContainer(arrayControls);

	CWnd* pWndPane1=GetPane(0,0);
	CWnd* pWndPane2=NULL;
	if(pControl->m_bVertical)
		pWndPane2=GetPane(0,1);
	else
		pWndPane2=GetPane(1,0);

	if(!pWndPane1 || !pWndPane2)
		return;

	PlaceControlOnPane(pControl->m_strFirstControlName,pWndPane1,arrayControls);
	PlaceControlOnPane(pControl->m_strSecondControlName,pWndPane2,arrayControls);
}


void CControlsSplitterWnd::RecalcLayout()
{
	CSplitterWnd::RecalcLayout();
	GetParentActiveXControl()->DelayControlsReposition();
}


void CControlsSplitterWnd::OnInvertTracker(const CRect& rect)
{
	ASSERT_VALID(this);
	ASSERT(!rect.IsRectEmpty());
	//ASSERT((GetStyle() & WS_CLIPCHILDREN) == 0);

	CRect rectContainer(rect);
	ClientToScreen(rectContainer);

	CWnd wndContainer;
	IOleClientSitePtr pOleClientSite=GetParentActiveXControl()->GetClientSite();
	wndContainer.m_hWnd=GetContainerWindow(pOleClientSite);
	wndContainer.ScreenToClient(rectContainer);

	DWORD dwOldStyle=wndContainer.GetStyle();
	::SetWindowLong(wndContainer.m_hWnd,GWL_STYLE,dwOldStyle&~WS_CLIPCHILDREN);
	
	// pat-blt without clip children on
	CDC* pDC = wndContainer.GetDC();
	// invert the brush pattern (looks just like frame window sizing)
	CBrush* pBrush = CDC::GetHalftoneBrush();
	HBRUSH hOldBrush = NULL;
	if (pBrush != NULL)
		hOldBrush = (HBRUSH)SelectObject(pDC->m_hDC, pBrush->m_hObject);
	pDC->PatBlt(rectContainer.left, 
				rectContainer.top, 
				rectContainer.Width(), 
				rectContainer.Height(), 
				PATINVERT);

	if (hOldBrush != NULL)
		SelectObject(pDC->m_hDC, hOldBrush);
	ReleaseDC(pDC);

	::SetWindowLong(wndContainer.m_hWnd,GWL_STYLE,dwOldStyle);
	wndContainer.m_hWnd=NULL;
}


