#if !defined(AFX_SPLITTERWINDOWCONTROLCTL_H__EF42CC74_68B4_11D2_B817_DDF1217C872F__INCLUDED_)
#define AFX_SPLITTERWINDOWCONTROLCTL_H__EF42CC74_68B4_11D2_B817_DDF1217C872F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// SplitterWindowControlCtl.h : Declaration of the CSplitterWindowControlCtrl ActiveX Control class.

#include "SplitterControlFrame.h"
#include <comdef.h>
#include <afxtempl.h>

struct CControlInfo
{
	CString			m_strName;
	IOleObjectPtr	m_pOleObject;

	CControlInfo& operator=(const CControlInfo& other)
	{
		m_strName=other.m_strName;
		m_pOleObject=other.m_pOleObject;
		return *this;
	}
};

class CControlInfoArray : public CArray<CControlInfo,CControlInfo&>
{
public:
	int IndexOf(LPCTSTR lpstrName);
};

class CSplitterWindowControlCtrl;

class CControlsSplitterWnd : public CSplitterWnd
{
// Operations
public:
	
	void SetFirstRowSize(int y)
	{
		TrackRowSize(y,0);
		RecalcLayout();
	}

	void SetFirstColumnSize(int x)
	{
		TrackColumnSize(x,0);
		RecalcLayout();
	}

	void PlaceControlOnPane(LPCTSTR lpstrControlName,CWnd* pWndPane,CControlInfoArray& arrayControls);
	void AdjustControlsToPanes();

	CSplitterWindowControlCtrl* GetParentActiveXControl();

	//Overrides
	virtual void RecalcLayout();    // call after changing sizes
	virtual void PostNcDestroy()
	{
		delete this;
	}

	virtual void OnInvertTracker(const CRect& rect);
};

/////////////////////////////////////////////////////////////////////////////
// CSplitterWindowControlCtrl : See SplitterWindowControlCtl.cpp for implementation.

class CSplitterWindowControlCtrl : public COleControl
{
	friend class CControlsSplitterWnd;
	DECLARE_DYNCREATE(CSplitterWindowControlCtrl)

	CSplitterControlFrame		m_wndFrame;
	CControlsSplitterWnd*		m_pSplitter;

// Constructor
public:
	CSplitterWindowControlCtrl();

	void GetOtherControlsOnTheContainer(CControlInfoArray& arrayControls);
	
	const CRect& GetPos() const
	{
		return m_rcPos;
	}

	BOOL IsUIActive() const
	{
		return m_bUIActive;
	}

	void DelayControlsReposition();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSplitterWindowControlCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual void OnAmbientPropertyChange(DISPID dispid);
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CSplitterWindowControlCtrl();

	DECLARE_OLECREATE_EX(CSplitterWindowControlCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CSplitterWindowControlCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CSplitterWindowControlCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CSplitterWindowControlCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CSplitterWindowControlCtrl)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMove(int x, int y);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CSplitterWindowControlCtrl)
	CString m_strFirstControlName;
	afx_msg void OnStrFirstControlNameChanged();
	CString m_strSecondControlName;
	afx_msg void OnStrSecondControlNameChanged();
	BOOL m_bVertical;
	afx_msg void OnBVerticalChanged();
	short m_intFirstPaneSize;
	afx_msg void OnIntFirstPaneSizeChanged();
	afx_msg long GetPointer();
	afx_msg void SetPointer(long nNewValue);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

	void RecreateSplitterWindow();
	void RepositionSplitter();
	short GetFirstPaneSize() const;
	void SetFirstPaneSize(short size);

	virtual BOOL CreateControlWindow(HWND hWndParent, const CRect& rcPos,
										LPCRECT prcClipped = NULL);

	CString GetExtendedName(IDispatchPtr pDispatch);
	

// Event maps
	//{{AFX_EVENT(CSplitterWindowControlCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CSplitterWindowControlCtrl)
	dispidStrFirstControlName = 1L,
	dispidStrSecondControlName = 2L,
	dispidBVertical = 3L,
	dispidIntFirstPaneSize = 4L,
	dispidPointer = 5L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPLITTERWINDOWCONTROLCTL_H__EF42CC74_68B4_11D2_B817_DDF1217C872F__INCLUDED)
